/* valaccodelabel.c generated by valac, the Vala compiler
 * generated from valaccodelabel.vala, do not modify */

/* valaccodelabel.vala
 *
 * Copyright (C) 2007  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include "valaccode.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValaCCodeLabelPrivate {
	gchar* _name;
};

static gint ValaCCodeLabel_private_offset;
static gpointer vala_ccode_label_parent_class = NULL;

static void vala_ccode_label_real_write (ValaCCodeNode* base,
                                  ValaCCodeWriter* writer);
static void vala_ccode_label_finalize (ValaCCodeNode * obj);
static GType vala_ccode_label_get_type_once (void);

static inline gpointer
vala_ccode_label_get_instance_private (ValaCCodeLabel* self)
{
	return G_STRUCT_MEMBER_P (self, ValaCCodeLabel_private_offset);
}

const gchar*
vala_ccode_label_get_name (ValaCCodeLabel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
vala_ccode_label_set_name (ValaCCodeLabel* self,
                           const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp0_;
}

ValaCCodeLabel*
vala_ccode_label_construct (GType object_type,
                            const gchar* name)
{
	ValaCCodeLabel* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValaCCodeLabel*) vala_ccode_statement_construct (object_type);
	vala_ccode_label_set_name (self, name);
	return self;
}

ValaCCodeLabel*
vala_ccode_label_new (const gchar* name)
{
	return vala_ccode_label_construct (VALA_TYPE_CCODE_LABEL, name);
}

static void
vala_ccode_label_real_write (ValaCCodeNode* base,
                             ValaCCodeWriter* writer)
{
	ValaCCodeLabel * self;
	const gchar* _tmp0_;
	self = (ValaCCodeLabel*) base;
	g_return_if_fail (writer != NULL);
	vala_ccode_writer_write_indent (writer, NULL);
	_tmp0_ = self->priv->_name;
	vala_ccode_writer_write_string (writer, _tmp0_);
	vala_ccode_writer_write_string (writer, ":");
	vala_ccode_writer_write_newline (writer);
}

static void
vala_ccode_label_class_init (ValaCCodeLabelClass * klass,
                             gpointer klass_data)
{
	vala_ccode_label_parent_class = g_type_class_peek_parent (klass);
	((ValaCCodeNodeClass *) klass)->finalize = vala_ccode_label_finalize;
	g_type_class_adjust_private_offset (klass, &ValaCCodeLabel_private_offset);
	((ValaCCodeNodeClass *) klass)->write = (void (*) (ValaCCodeNode*, ValaCCodeWriter*)) vala_ccode_label_real_write;
}

static void
vala_ccode_label_instance_init (ValaCCodeLabel * self,
                                gpointer klass)
{
	self->priv = vala_ccode_label_get_instance_private (self);
}

static void
vala_ccode_label_finalize (ValaCCodeNode * obj)
{
	ValaCCodeLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_CCODE_LABEL, ValaCCodeLabel);
	_g_free0 (self->priv->_name);
	VALA_CCODE_NODE_CLASS (vala_ccode_label_parent_class)->finalize (obj);
}

/**
 * Represents a label declaration in the C code.
 */
static GType
vala_ccode_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaCCodeLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodeLabel), 0, (GInstanceInitFunc) vala_ccode_label_instance_init, NULL };
	GType vala_ccode_label_type_id;
	vala_ccode_label_type_id = g_type_register_static (VALA_TYPE_CCODE_STATEMENT, "ValaCCodeLabel", &g_define_type_info, 0);
	ValaCCodeLabel_private_offset = g_type_add_instance_private (vala_ccode_label_type_id, sizeof (ValaCCodeLabelPrivate));
	return vala_ccode_label_type_id;
}

GType
vala_ccode_label_get_type (void)
{
	static volatile gsize vala_ccode_label_type_id__once = 0;
	if (g_once_init_enter (&vala_ccode_label_type_id__once)) {
		GType vala_ccode_label_type_id;
		vala_ccode_label_type_id = vala_ccode_label_get_type_once ();
		g_once_init_leave (&vala_ccode_label_type_id__once, vala_ccode_label_type_id);
	}
	return vala_ccode_label_type_id__once;
}

