/* valaccodepragma.c generated by valac, the Vala compiler
 * generated from valaccodepragma.vala, do not modify */

/* valaccodepragma.vala
 *
 * Copyright (C) 2024  Rico Tzschichholz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Rico Tzschichholz <ricotz@ubuntu.com>
 */

#include "valaccode.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValaCCodePragmaPrivate {
	gchar* _prefix;
	gchar* _directive;
	gchar* _value;
};

static gint ValaCCodePragma_private_offset;
static gpointer vala_ccode_pragma_parent_class = NULL;

static void vala_ccode_pragma_real_write (ValaCCodeNode* base,
                                   ValaCCodeWriter* writer);
static void vala_ccode_pragma_finalize (ValaCCodeNode * obj);
static GType vala_ccode_pragma_get_type_once (void);

static inline gpointer
vala_ccode_pragma_get_instance_private (ValaCCodePragma* self)
{
	return G_STRUCT_MEMBER_P (self, ValaCCodePragma_private_offset);
}

const gchar*
vala_ccode_pragma_get_prefix (ValaCCodePragma* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_prefix;
	result = _tmp0_;
	return result;
}

void
vala_ccode_pragma_set_prefix (ValaCCodePragma* self,
                              const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_prefix);
	self->priv->_prefix = _tmp0_;
}

const gchar*
vala_ccode_pragma_get_directive (ValaCCodePragma* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_directive;
	result = _tmp0_;
	return result;
}

void
vala_ccode_pragma_set_directive (ValaCCodePragma* self,
                                 const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_directive);
	self->priv->_directive = _tmp0_;
}

const gchar*
vala_ccode_pragma_get_value (ValaCCodePragma* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_value;
	result = _tmp0_;
	return result;
}

void
vala_ccode_pragma_set_value (ValaCCodePragma* self,
                             const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_value);
	self->priv->_value = _tmp0_;
}

ValaCCodePragma*
vala_ccode_pragma_construct (GType object_type,
                             const gchar* prefix,
                             const gchar* directive,
                             const gchar* value)
{
	ValaCCodePragma* self = NULL;
	g_return_val_if_fail (prefix != NULL, NULL);
	g_return_val_if_fail (directive != NULL, NULL);
	self = (ValaCCodePragma*) vala_ccode_node_construct (object_type);
	vala_ccode_pragma_set_prefix (self, prefix);
	vala_ccode_pragma_set_directive (self, directive);
	vala_ccode_pragma_set_value (self, value);
	return self;
}

ValaCCodePragma*
vala_ccode_pragma_new (const gchar* prefix,
                       const gchar* directive,
                       const gchar* value)
{
	return vala_ccode_pragma_construct (VALA_TYPE_CCODE_PRAGMA, prefix, directive, value);
}

static void
vala_ccode_pragma_real_write (ValaCCodeNode* base,
                              ValaCCodeWriter* writer)
{
	ValaCCodePragma * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (ValaCCodePragma*) base;
	g_return_if_fail (writer != NULL);
	vala_ccode_writer_write_indent (writer, NULL);
	vala_ccode_writer_write_string (writer, "#pragma ");
	_tmp0_ = self->priv->_prefix;
	vala_ccode_writer_write_string (writer, _tmp0_);
	vala_ccode_writer_write_string (writer, " ");
	_tmp1_ = self->priv->_directive;
	vala_ccode_writer_write_string (writer, _tmp1_);
	_tmp2_ = self->priv->_value;
	if (_tmp2_ != NULL) {
		const gchar* _tmp3_;
		vala_ccode_writer_write_string (writer, " ");
		_tmp3_ = self->priv->_value;
		vala_ccode_writer_write_string (writer, _tmp3_);
	}
	vala_ccode_writer_write_newline (writer);
}

static void
vala_ccode_pragma_class_init (ValaCCodePragmaClass * klass,
                              gpointer klass_data)
{
	vala_ccode_pragma_parent_class = g_type_class_peek_parent (klass);
	((ValaCCodeNodeClass *) klass)->finalize = vala_ccode_pragma_finalize;
	g_type_class_adjust_private_offset (klass, &ValaCCodePragma_private_offset);
	((ValaCCodeNodeClass *) klass)->write = (void (*) (ValaCCodeNode*, ValaCCodeWriter*)) vala_ccode_pragma_real_write;
}

static void
vala_ccode_pragma_instance_init (ValaCCodePragma * self,
                                 gpointer klass)
{
	self->priv = vala_ccode_pragma_get_instance_private (self);
}

static void
vala_ccode_pragma_finalize (ValaCCodeNode * obj)
{
	ValaCCodePragma * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_CCODE_PRAGMA, ValaCCodePragma);
	_g_free0 (self->priv->_prefix);
	_g_free0 (self->priv->_directive);
	_g_free0 (self->priv->_value);
	VALA_CCODE_NODE_CLASS (vala_ccode_pragma_parent_class)->finalize (obj);
}

/**
 * Represents a pragma in the C code.
 */
static GType
vala_ccode_pragma_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaCCodePragmaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_pragma_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodePragma), 0, (GInstanceInitFunc) vala_ccode_pragma_instance_init, NULL };
	GType vala_ccode_pragma_type_id;
	vala_ccode_pragma_type_id = g_type_register_static (VALA_TYPE_CCODE_NODE, "ValaCCodePragma", &g_define_type_info, 0);
	ValaCCodePragma_private_offset = g_type_add_instance_private (vala_ccode_pragma_type_id, sizeof (ValaCCodePragmaPrivate));
	return vala_ccode_pragma_type_id;
}

GType
vala_ccode_pragma_get_type (void)
{
	static volatile gsize vala_ccode_pragma_type_id__once = 0;
	if (g_once_init_enter (&vala_ccode_pragma_type_id__once)) {
		GType vala_ccode_pragma_type_id;
		vala_ccode_pragma_type_id = vala_ccode_pragma_get_type_once ();
		g_once_init_leave (&vala_ccode_pragma_type_id__once, vala_ccode_pragma_type_id);
	}
	return vala_ccode_pragma_type_id__once;
}

