/* valaerrordomainregisterfunction.c generated by valac, the Vala compiler
 * generated from valaerrordomainregisterfunction.vala, do not modify */

/* valaerrordomainregisterfunction.vala
 *
 * Copyright (C) 2018  Rico Tzschichholz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Rico Tzschichholz <ricotz@ubuntu.com>
 */

#include "valacodegen.h"
#include <vala.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

struct _ValaErrorDomainRegisterFunctionPrivate {
	ValaErrorDomain* _error_domain_reference;
};

static gint ValaErrorDomainRegisterFunction_private_offset;
static gpointer vala_error_domain_register_function_parent_class = NULL;

static ValaTypeSymbol* vala_error_domain_register_function_real_get_type_declaration (ValaTypeRegisterFunction* base);
static ValaSymbolAccessibility vala_error_domain_register_function_real_get_accessibility (ValaTypeRegisterFunction* base);
static void vala_error_domain_register_function_finalize (ValaTypeRegisterFunction * obj);
static GType vala_error_domain_register_function_get_type_once (void);

static inline gpointer
vala_error_domain_register_function_get_instance_private (ValaErrorDomainRegisterFunction* self)
{
	return G_STRUCT_MEMBER_P (self, ValaErrorDomainRegisterFunction_private_offset);
}

ValaErrorDomain*
vala_error_domain_register_function_get_error_domain_reference (ValaErrorDomainRegisterFunction* self)
{
	ValaErrorDomain* result;
	ValaErrorDomain* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_error_domain_reference;
	result = _tmp0_;
	return result;
}

void
vala_error_domain_register_function_set_error_domain_reference (ValaErrorDomainRegisterFunction* self,
                                                                ValaErrorDomain* value)
{
	g_return_if_fail (self != NULL);
	self->priv->_error_domain_reference = value;
}

/**
 * Creates a new C function to register the specified error domain at runtime.
 *
 * @param edomain an error domain
 * @return        newly created error domain register function
 */
ValaErrorDomainRegisterFunction*
vala_error_domain_register_function_construct (GType object_type,
                                               ValaErrorDomain* edomain)
{
	ValaErrorDomainRegisterFunction* self = NULL;
	g_return_val_if_fail (edomain != NULL, NULL);
	self = (ValaErrorDomainRegisterFunction*) vala_typeregister_function_construct (object_type);
	vala_error_domain_register_function_set_error_domain_reference (self, edomain);
	return self;
}

ValaErrorDomainRegisterFunction*
vala_error_domain_register_function_new (ValaErrorDomain* edomain)
{
	return vala_error_domain_register_function_construct (VALA_TYPE_ERROR_DOMAIN_REGISTER_FUNCTION, edomain);
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

static ValaTypeSymbol*
vala_error_domain_register_function_real_get_type_declaration (ValaTypeRegisterFunction* base)
{
	ValaErrorDomainRegisterFunction * self;
	ValaErrorDomain* _tmp0_;
	ValaTypeSymbol* _tmp1_;
	ValaTypeSymbol* result;
	self = (ValaErrorDomainRegisterFunction*) base;
	_tmp0_ = self->priv->_error_domain_reference;
	_tmp1_ = _vala_code_node_ref0 ((ValaTypeSymbol*) _tmp0_);
	result = _tmp1_;
	return result;
}

static ValaSymbolAccessibility
vala_error_domain_register_function_real_get_accessibility (ValaTypeRegisterFunction* base)
{
	ValaErrorDomainRegisterFunction * self;
	ValaErrorDomain* _tmp0_;
	ValaSymbolAccessibility _tmp1_;
	ValaSymbolAccessibility _tmp2_;
	ValaSymbolAccessibility result;
	self = (ValaErrorDomainRegisterFunction*) base;
	_tmp0_ = self->priv->_error_domain_reference;
	_tmp1_ = vala_symbol_get_access ((ValaSymbol*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static void
vala_error_domain_register_function_class_init (ValaErrorDomainRegisterFunctionClass * klass,
                                                gpointer klass_data)
{
	vala_error_domain_register_function_parent_class = g_type_class_peek_parent (klass);
	((ValaTypeRegisterFunctionClass *) klass)->finalize = vala_error_domain_register_function_finalize;
	g_type_class_adjust_private_offset (klass, &ValaErrorDomainRegisterFunction_private_offset);
	((ValaTypeRegisterFunctionClass *) klass)->get_type_declaration = (ValaTypeSymbol* (*) (ValaTypeRegisterFunction*)) vala_error_domain_register_function_real_get_type_declaration;
	((ValaTypeRegisterFunctionClass *) klass)->get_accessibility = (ValaSymbolAccessibility (*) (ValaTypeRegisterFunction*)) vala_error_domain_register_function_real_get_accessibility;
}

static void
vala_error_domain_register_function_instance_init (ValaErrorDomainRegisterFunction * self,
                                                   gpointer klass)
{
	self->priv = vala_error_domain_register_function_get_instance_private (self);
}

static void
vala_error_domain_register_function_finalize (ValaTypeRegisterFunction * obj)
{
	ValaErrorDomainRegisterFunction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_ERROR_DOMAIN_REGISTER_FUNCTION, ValaErrorDomainRegisterFunction);
	VALA_TYPEREGISTER_FUNCTION_CLASS (vala_error_domain_register_function_parent_class)->finalize (obj);
}

/**
 * C function to register an error domain at runtime.
 */
static GType
vala_error_domain_register_function_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaErrorDomainRegisterFunctionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_error_domain_register_function_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaErrorDomainRegisterFunction), 0, (GInstanceInitFunc) vala_error_domain_register_function_instance_init, NULL };
	GType vala_error_domain_register_function_type_id;
	vala_error_domain_register_function_type_id = g_type_register_static (VALA_TYPE_TYPEREGISTER_FUNCTION, "ValaErrorDomainRegisterFunction", &g_define_type_info, 0);
	ValaErrorDomainRegisterFunction_private_offset = g_type_add_instance_private (vala_error_domain_register_function_type_id, sizeof (ValaErrorDomainRegisterFunctionPrivate));
	return vala_error_domain_register_function_type_id;
}

GType
vala_error_domain_register_function_get_type (void)
{
	static volatile gsize vala_error_domain_register_function_type_id__once = 0;
	if (g_once_init_enter (&vala_error_domain_register_function_type_id__once)) {
		GType vala_error_domain_register_function_type_id;
		vala_error_domain_register_function_type_id = vala_error_domain_register_function_get_type_once ();
		g_once_init_leave (&vala_error_domain_register_function_type_id__once, vala_error_domain_register_function_type_id);
	}
	return vala_error_domain_register_function_type_id__once;
}

